; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
xrot	equ rot
yrot	equ rot+4
zrot	equ rot+8
xspeed	equ speed
yspeed	equ speed+4
zspeed	equ speed+8
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
POINT_3D struct			; Structure for a 3-dimensional point (NEW)
	x dq ?
	y dq ?
	z dq ?
POINT_3D ends
BEZIER_PATCH struct
	anchors POINT_3D 16 dup (<>); 4x4 grid of anchor points
	dlBPatch dd ?; Display List for Bezier Patch
	texture dd ?; Texture for the patch
BEZIER_PATCH ends
TEXTURE_IMAGE struct
  sizeX		dd ?; Width Of Image In Pixels
  sizeY		dd ?; Height Of Image In Pixels
  data_		dd ?; Texture Data
TEXTURE_IMAGE ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	TextureImage:TEXTURE_IMAGE
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
local	texture:qword
local	hFile:qword
local	mem:dword
local	buff[10h]:dword

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
;----------------------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
@@:	cmp	al,VK_LEFT
	jne	@f
	movss	xmm0,zrot
	subss	xmm0,zspeed
	movss	zrot,xmm0;rotz -= 0.8f;		// rotate left
	jmp	@0
@@:	cmp	al,VK_RIGHT
	jne	@f
	movss	xmm0,zrot
	addss	xmm0,zspeed
	movss	zrot,xmm0;rotz += 0.8f;		// rotate right
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f;resolution up
	cmp	divs,9
	ja	wmBYE
	inc	divs
	invoke	genBezier;,mybezier, divs; Update the patch
	mov	mybezier.dlBPatch,eax
	jmp	@0
@@:	cmp	al,VK_DOWN
	jne	@f
	cmp	divs,1
	jna	wmBYE
	dec	divs
	invoke	genBezier;,mybezier, divs; Update the patch
	mov	mybezier.dlBPatch,eax
	jmp	@0
@@:	cmp	al,VK_SPACE
	jne	wmBYE
;SPACE toggles showCPoints
	xor	showCPoints,1
@0:	invoke	InvalidateRect,hWin,0,0
        jmp	wmBYE
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	invoke	glEnable,GL_TEXTURE_2D; Enable Texture Mapping
	invoke	glShadeModel,GL_SMOOTH; Enable Smooth Shading
	movss	xmm3,const0_5
	movss	xmm2,const0_05
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glClearColor;(0.05f, 0.05f, 0.05f, 0.5f); Black Background
	cvtss2sd xmm0,const1
	invoke	glClearDepth;(1.0f); Depth Buffer Setup
	invoke	glEnable,GL_DEPTH_TEST; Enables Depth Testing
	invoke	glDepthFunc,GL_LEQUAL; The Type Of Depth Testing To Do
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations

; Load the texture
	mov	edx,offset mybezier.texture
	invoke	glGenTextures,1; Generate 1 texture
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	hFile,rax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	mem,eax
        mov	esi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,FSize,,rbx
        invoke	CloseHandle,hFile
	mov	eax,[rsi + sizeof BITMAPFILEHEADER + BITMAPINFOHEADER.biWidth]
        mov	TextureImage.sizeX,eax
        movzx	eax, word ptr [rsi + sizeof BITMAPFILEHEADER + BITMAPINFOHEADER.biHeight]
        mov	TextureImage.sizeY,eax
        add	esi,[rsi + BITMAPFILEHEADER.bfOffBits]
	mov	TextureImage.data_,esi
;
; Typical Texture Generation Using Data From The Bitmap
	mov	edx,mybezier.texture
	invoke	glBindTexture,GL_TEXTURE_2D
	xor	edx,edx
	mov	r9d,TextureImage.sizeX
	mov	eax,TextureImage.sizeY
	mov	[rsp+20h],rax
	mov	[rsp+28h],rdx
        mov	qword ptr [rsp+30h],GL_BGR_EXT
	mov	qword ptr [rsp+38h],GL_UNSIGNED_BYTE
	mov	eax,TextureImage.data_
	mov	[rsp+40h],rax
	invoke	glTexImage2D,GL_TEXTURE_2D,,3
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR;
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR;
	mov	ecx,mem
	invoke	GlobalFree
	invoke	genBezier;(mybezier, divs); Generate the patch
	mov	mybezier.dlBPatch,eax

        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT; Clear Screen And Depth Buffer
	invoke	glLoadIdentity; Reset The Current Modelview Matrix
	movss	xmm2,const_4
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glTranslatef;(0.0f,0.0f,-4.0f);						// Move Left 1.5 Units And Into The Screen 6.0
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	movss	xmm1,const1
	movss	xmm0,const_75
	invoke	glRotatef;(-75.0f,1.0f,0.0f,0.0f);
	movss	xmm3,const1
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,zrot
	invoke	glRotatef;(rotz,0.0f,0.0f,1.0f);						// Rotate The Triangle On The Z axis ( NEW )
	mov	ecx,mybezier.dlBPatch
	invoke	glCallList; Call the Bezier's display list
; this need only be updated when the patch changes

	cmp	showCPoints,0; If drawing the grid is toggled on
	jz	exit0
	invoke	glDisable,GL_TEXTURE_2D
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	movss	xmm0,const1
	invoke	glColor3f;(1.0f,0.0f,0.0f);
;--------------------------------------------------
	xor	esi,esi;for(i=0;i<4;i++) {	// draw the horizontal lines
@1:	invoke	glBegin,GL_LINE_STRIP;
	xor	edi,edi;for(j=0;j<4;j++)
@@:    	movq	xmm2,mybezier.anchors[rdi+rsi].z
	movq	xmm1,mybezier.anchors[rdi+rsi].y
	movq	xmm0,mybezier.anchors[rdi+rsi].x
	invoke	glVertex3d;(mybezier.anchors[i][j].x, mybezier.anchors[i][j].y, mybezier.anchors[i][j].z
	add	edi,24
	cmp	edi,4*24
	jb	@b	
	invoke	glEnd;
	add	esi,edi;96;sizeof POINT_3D
	cmp	esi,96*4;4*(sizeof POINT_3D)
	jb	@1

	xor	esi,esi;for(i=0;i<4;i++) {	// draw the vertical lines
@2:	invoke	glBegin,GL_LINE_STRIP;
	xor	edi,edi;for(j=0;j<4;j++)
@@:    	movq	xmm2,mybezier.anchors[rdi+rsi].z
	movq	xmm1,mybezier.anchors[rdi+rsi].y
	movq	xmm0,mybezier.anchors[rdi+rsi].x
	invoke	glVertex3d;(mybezier.anchors[j][i].x, mybezier.anchors[j][i].y, mybezier.anchors[j][i].z
	add	edi,96
	cmp	edi,96*4
	jb	@b
	invoke	glEnd;
	add	esi,24;sizeof POINT_3D
	cmp	esi,24*4;4*(sizeof POINT_3D)
	jb	@2
	movss	xmm2,const1
	movss	xmm1,xmm2
	movss	xmm0,xmm2
	invoke	glColor3f;(1.0f,1.0f,1.0f);
	invoke	glEnable,GL_TEXTURE_2D
exit0:
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
;Adds 2 points
pointAdd proc dest:dword,p:dword,q:dword

	movsd	xmm0,[rdx].POINT_3D.x
	addsd	xmm0,[r8].POINT_3D.x
	movsd	[rcx].POINT_3D.x,xmm0;	p.x += q.x
	movsd	xmm0,[rdx].POINT_3D.y
	addsd	xmm0,[r8].POINT_3D.y
	movsd	[rcx].POINT_3D.y,xmm0;	p.x += q.x
	movsd	xmm0,[rdx].POINT_3D.z
	addsd	xmm0,[r8].POINT_3D.z
	movsd	[rcx].POINT_3D.z,xmm0;	p.x += q.x
	leave
	ret
pointAdd endp
;Multiplies a point and a constant
pointTimes proc dest:dword,c_:qword,p:dword

	movsd	xmm0,[r8].POINT_3D.x
	mulsd	xmm0,xmm1
	movsd	[rcx].POINT_3D.x,xmm0
	movsd	xmm0,[r8].POINT_3D.y
	mulsd	xmm0,xmm1
	movsd	[rcx].POINT_3D.y,xmm0
	movsd	xmm0,[r8].POINT_3D.z
	mulsd	xmm0,xmm1
	movsd	[rcx].POINT_3D.z,xmm0
	leave
	ret
pointTimes endp
;Calculates 3rd degree polynomial based on array of 4 points
;and a single variable (u) which is generally between 0 and 1
Bernstein proc dest:dword,u:dword,p:dword
local	a:POINT_3D
local	b:POINT_3D
local	c_:POINT_3D
local	d:POINT_3D
local	temp1:POINT_3D
local	temp2:POINT_3D
local	r:POINT_3D
local	buff[10h]:dword

	push	rsi
	push	rdi
	mov	dest,ecx
	movss	u,xmm1
	mov	edi,r8d

	movss	xmm0,u
	mulss	xmm0,xmm0
	mulss	xmm0,u
	cvtss2sd xmm1,xmm0
	lea	ecx,a
	lea	r8d,[rdi+0*24]
	invoke	pointTimes;a = pointTimes(u*u*u), p[0])
	movss	xmm0,u
	mulss	xmm0,xmm0
	mulss	xmm0,const3
	movss	xmm1,const1
	subss	xmm1,u
	mulss	xmm0,xmm1
	cvtss2sd xmm1,xmm0
	lea	ecx,b
	lea	r8d,[rdi+1*24]
	invoke	pointTimes;b = pointTimes(3*u*u*(1-u), p[1]);
	movss	xmm0,const1
	subss	xmm0,u
	mulss	xmm0,xmm0
	mulss	xmm0,const3
	mulss	xmm0,u
	cvtss2sd xmm1,xmm0
	lea	ecx,c_
	lea	r8d,[rdi+2*24]
	invoke	pointTimes;c = pointTimes(3*u*(1-u)*(1-u), p[2]);
	movss	xmm0,const1
	subss	xmm0,u
	movss	xmm1,xmm0
	mulss	xmm0,xmm0
	mulss	xmm0,xmm1
	cvtss2sd xmm1,xmm0
	lea	ecx,d
	lea	r8d,[rdi+3*24]
	invoke	pointTimes;d = pointTimes((1-u)*(1-u)*(1-u), p[3]);
;pointAdd proc dest:dword,p_x:qword,p_y:qword,p_z:qword,q_x:qword,q_y:qword,q_z:qword
	lea	ecx,temp1
	lea	edx,a
	lea	r8d,b
	invoke	pointAdd
	lea	ecx,temp2
	lea	edx,c_
	lea	r8d,d
	invoke	pointAdd
	lea	ecx,r
	lea	edx,temp1
	lea	r8d,temp2
	invoke	pointAdd;	r = pointAdd(pointAdd(a, b), pointAdd(c, d));
	lea	esi,r
	mov	edi,dest
	mov	ecx,3
	rep	movsq;	return r
	pop	rdi
	pop	rsi
	leave
	ret
Bernstein endp
genBezier proc ;BEZIER_PATCH patch, int divs
local	temp[4]:POINT_3D
local	drawlist:dword
local	px:dword
local	py:dword
local	pyold:dword
local	last:dword
local	u:dword
local	v0:dword
local	tmp:dword
local	buff[10h]:dword


	invoke	glGenLists,1		;  
	mov	drawlist,eax
;      
	mov	edx,divs
	inc	edx
	imul	edx,sizeof POINT_3D
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED
	mov	last,eax
	mov	ecx,mybezier.dlBPatch
	or	ecx,ecx
	jz	@f
	invoke	glDeleteLists,,1;   
@@:	;   (  X)
	push	rsi
	push	rdi
	lea	edi,temp
	mov	esi,offset mybezier.anchors[0*60h+3*(sizeof POINT_3D)].x
	mov	ecx,3
	rep	movsq;temp[0] = patch.anchors[0][3]; the first derived curve (along x axis)
	add	esi,3*(sizeof POINT_3D)
	mov	ecx,3
	rep	movsq;	temp[1] = patch.anchors[1][3];
	add	esi,3*(sizeof POINT_3D)
	mov	ecx,3
	rep	movsq;	temp[2] = patch.anchors[2][3];
	add	esi,3*(sizeof POINT_3D)
	mov	ecx,3
	rep	movsq;	temp[3] = patch.anchors[3][3]

; the first derived curve (along x axis)
	imul	eax,divs,(sizeof POINT_3D)
	mov	tmp,eax
	xor	esi,esi;for (v0=0;v0<=divs;v0++) {	;   
@@:	cvtsi2ss xmm1,esi
	cvtsi2ss xmm0,tmp;divs*(sizeof POINT_3D)
	divss	xmm1,xmm0
	movss	px,xmm1;px = ((float)v0)/((float)divs);    X
; 4         
	mov	ecx,last
	add	ecx,esi
	lea	r8d,temp
	invoke	Bernstein;last[v0] = Bernstein(px, temp);
	add	esi,(sizeof POINT_3D)
	cmp	esi,tmp
	jbe	@b
	mov	ecx,drawlist
	invoke	glNewList,,GL_COMPILE;    
	mov	edx,mybezier.texture
	invoke	glBindTexture,GL_TEXTURE_2D;, patch.texture);  

	mov	esi,(sizeof POINT_3D);	for (u=1;u<=divs;u++) {
@2:	cvtsi2ss xmm0,esi
        cvtsi2ss xmm1,tmp
	divss	xmm0,xmm1
	movss	py,xmm0;py = ((float)u)/((float)divs)	   Y
	cvtsi2ss xmm0,esi
	subss	xmm0,const24
	divss	xmm0,xmm1
	movss	pyold,xmm0;pyold = (u-1.0)/divs)     Y
	lea	ecx,temp[0*(sizeof POINT_3D)]
	movss	xmm1,py
	mov	r8d,offset mybezier.anchors[0*96].x
	invoke	Bernstein;Bernstein(temp[0],py, patch.anchors[0]);   
	lea	ecx,temp[1*(sizeof POINT_3D)]
	movss	xmm1,py
	mov	r8d,offset mybezier.anchors[1*96].x
	invoke	Bernstein;Bernstein(temp[1],py, patch.anchors[1])
	lea	ecx,temp[2*(sizeof POINT_3D)]
	movss	xmm1,py
	mov	r8d,offset mybezier.anchors[2*96].x
	invoke	Bernstein;Bernstein(temp[2],py, patch.anchors[2])
	lea	ecx,temp[3*(sizeof POINT_3D)]
	movss	xmm1,py
	mov	r8d,offset mybezier.anchors[3*96].x
	invoke	Bernstein;Bernstein(temp[3],py, patch.anchors[3])
	invoke	glBegin,GL_TRIANGLE_STRIP;   

	xor	edi,edi;for (v0=0;v0<=divs;v0++) {
@3:	cvtsi2ss xmm1,edi
	cvtsi2ss xmm0,tmp
	divss	xmm1,xmm0
	movss	px,xmm1;px = ((float)v0)/((float)divs);   X
	movss	xmm0,pyold
	invoke	glTexCoord2f;(pyold, px);   
	mov	eax,last
	movq	xmm2,[rax+rdi].POINT_3D.z
	movq	xmm1,[rax+rdi].POINT_3D.y
	movq	xmm0,[rax+rdi].POINT_3D.x
	invoke	glVertex3d;(last[v0].x, last[v0].y, last[v0].z); 
	mov	ecx,last
	add	ecx,edi
	movss	xmm1,px
	lea	r8d,temp
	invoke	Bernstein;Bernstein(last[v0], px, temp);  
	movss	xmm1,px
	movss	xmm0,py
	invoke	glTexCoord2f;py, px;   
	mov	eax,last
	movq	xmm2,[rax+rdi].POINT_3D.z
	movq	xmm1,[rax+rdi].POINT_3D.y
	movq	xmm0,[rax+rdi].POINT_3D.x
	invoke	glVertex3d;(last[v0].x, last[v0].y, last[v0].z); 
	add	edi,(sizeof POINT_3D)
	cmp	edi,tmp
	jbe	@3;le	@3
@4:	invoke	glEnd;   
	add	esi,(sizeof POINT_3D);inc	u
;	mov	eax,divs
	cmp	esi,tmp;u,eax;cmp	esi,temp1
	jbe	@2	

@5:	invoke	glEndList; 
	mov	ecx,last
	invoke	GlobalFree;   
	mov	eax,drawlist;  
	mov	mybezier.dlBPatch,eax
	pop	rdi
	pop	rsi
	leave
	ret
genBezier endp
;---------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson #28: Bezier Tutorial",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "NeHe.bmp",0
mybezier	label BEZIER_PATCH
	anchors POINT_3D <-0.75,-0.75,-0.5>; 4x4 grid of anchor points
                POINT_3D <-0.25,-0.75, 0>
                POINT_3D < 0.25,-0.75, 0>
                POINT_3D < 0.75,-0.75,-0.5>

                POINT_3D <-0.75,-0.25,-0.75>
                POINT_3D <-0.25,-0.25, 0.5>
                POINT_3D < 0.25,-0.25, 0.5>
                POINT_3D < 0.75,-0.25,-0.75>

                POINT_3D <-0.75, 0.25, 0>
                POINT_3D <-0.25, 0.25,-0.5>
                POINT_3D < 0.25, 0.25,-0.5>
                POINT_3D < 0.75, 0.25, 0>

                POINT_3D <-0.75, 0.75,-0.5>
                POINT_3D <-0.25, 0.75,-1.0>
                POINT_3D < 0.25, 0.75,-1.0>
                POINT_3D < 0.75, 0.75,-0.5>
	dlBPatch dd ?; Display List for Bezier Patch
	texture dd ?; Texture for the patch
showCPoints	db TRUE
divs		dd 7
;-----------------------------
;float
const0_05	dd 0.05
const0_5	dd 0.5
const1		dd 1.0
const3		dd 3.0
const_4		dd -4.0
const24		dd 24.0
const_75	dd -75.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
align 16
rot		dd 0,  0,   0,  0
speed		dd 0,  0, 0.8,  0
end